@echo off

rem **************************************************************************
rem
if not "%1" == "" goto :parmsok1
echo usage: pictest programmer device_name
goto :the_end

:parmsok1

if not "%2" == "" goto :parmsok2
echo usage: pictest programmer device_name
goto :the_end

:parmsok2



rem **************************************************************************
rem
set pcmd=fpp %1
set device_name=%2

set pcmd_test_programmer=%pcmd% -t

set pcmd_print_device_id=%pcmd% %device_name% -i

set pcmd_print_config=%pcmd% %device_name% -c

set pcmd_erase_chip=%pcmd% %device_name% -e
set pcmd_erase_data_mem=%pcmd% %device_name% -ed
set pcmd_erase_prog_mem=%pcmd% %device_name% -ep

set pcmd_blank_check=%pcmd% %device_name% -b

set pcmd_prog_data_mem=%pcmd% %device_name% -p %device_name%_data_eeprom.hex
set pcmd_verify_data_mem=%pcmd% %device_name% -v %device_name%_data_eeprom.hex

set pcmd_prog_prog_mem=%pcmd% %device_name% -p %device_name%_program_eeprom.hex
set pcmd_verify_prog_mem=%pcmd% %device_name% -v %device_name%_program_eeprom.hex

set pcmd_prog_idloc_mem=%pcmd% %device_name% -p %device_name%_idloc.hex
set pcmd_verify_idloc_mem=%pcmd% %device_name% -v %device_name%_idloc.hex

set pcmd_prog_config_cp_off=%pcmd% %device_name% -p %device_name%_config_cp_off.hex
set pcmd_verify_config_cp_off=%pcmd% %device_name% -v %device_name%_config_cp_off.hex

set pcmd_prog_config_cp_on=%pcmd% %device_name% -p %device_name%_config_cp_on.hex
set pcmd_verify_config_cp_on=%pcmd% %device_name% -v %device_name%_config_cp_on.hex

set pcmd_prog_all_mem=%pcmd% %device_name% -p %device_name%_all_eeprom.hex
set pcmd_verify_all_mem=%pcmd% %device_name% -v %device_name%_all_eeprom.hex


echo *************************************************************************
echo ** test if programmer is connected
echo *************************************************************************
echo.
echo *** test if programmer is connected
rem
set runcmd=%pcmd_test_programmer%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo ** print device id
echo *************************************************************************
echo.
echo *** print device id
rem
set runcmd=%pcmd_print_device_id%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo ** print config word
echo *************************************************************************
echo.
echo *** print config
rem
set runcmd=%pcmd_print_config%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo ** start with a blank device
echo *************************************************************************
echo.
echo *** erase chip
rem
set runcmd=%pcmd_erase_chip%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** blank check
rem
set runcmd=%pcmd_blank_check%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo *** test prog/verify/erase of data memory
echo *************************************************************************
echo.
echo *** program data memory
rem
set runcmd=%pcmd_prog_data_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** verify data memory
rem
set runcmd=%pcmd_verify_data_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** erase data memory
rem
set runcmd=%pcmd_erase_data_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** blank check
rem
set runcmd=%pcmd_blank_check%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo ** test prog/verify/erase of program memory
echo *************************************************************************
echo.
echo *** program prog memory
set runcmd=%pcmd_prog_prog_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** verify prog memory
rem
set runcmd=%pcmd_verify_prog_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** erase prog memory
rem
set runcmd=%pcmd_erase_prog_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** blank check
rem
set runcmd=%pcmd_blank_check%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo *** test prog/verify/erase of id locations
echo *************************************************************************
echo.
echo *** program idloc memory
set runcmd=%pcmd_prog_idloc_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** verify idloc memory
rem
set runcmd=%pcmd_verify_idloc_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** erase chip
rem
set runcmd=%pcmd_erase_chip%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** blank check
rem
set runcmd=%pcmd_blank_check%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo *** test programming the code protection bits
echo *** test erase program/data memory with code protection enabled
echo *** test clearing the code protection by erasing the entire device
echo *************************************************************************
echo.
echo *** program data memory
rem
set runcmd=%pcmd_prog_data_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** verify data memory
rem
set runcmd=%pcmd_verify_data_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** program prog memory
rem
set runcmd=%pcmd_prog_prog_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** verify prog memory
rem
set runcmd=%pcmd_verify_prog_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** program config cp off
rem
set runcmd=%pcmd_prog_config_cp_off%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** verify config cp off
rem
set runcmd=%pcmd_verify_config_cp_off%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** program config cp on *** verify may fail after cp is set ***
rem
set runcmd=%pcmd_prog_config_cp_on%
@echo on
%runcmd%
@echo off

echo *** verify config cp on *** verify may fail after cp is set ***
rem
set runcmd=%pcmd_verify_config_cp_on%
@echo on
%runcmd%
@echo off

echo *** erase data memory *** must fail because code protection is set ***
rem
set runcmd=%pcmd_erase_data_mem%
@echo on
%runcmd%
@echo off
if not errorlevel 1 goto :cmdfail

echo *** erase prog memory *** this may fail because cp is set ***
rem
set runcmd=%pcmd_erase_prog_mem%
@echo on
%runcmd%
@echo off

echo *** erase chip
rem
set runcmd=%pcmd_erase_chip%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** blank check
rem
set runcmd=%pcmd_blank_check%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo *** test programming/erasing all memory locations at once
echo *************************************************************************
echo.
echo *** program all
rem
set runcmd=%pcmd_prog_all_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** verify all
rem
set runcmd=%pcmd_verify_all_mem%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** erase chip
rem
set runcmd=%pcmd_erase_chip%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *** blank check
rem
set runcmd=%pcmd_blank_check%
@echo on
%runcmd%
@echo off
if errorlevel 1 goto :cmdfail

echo *************************************************************************
echo *** ALL TESTS PASSED ***
echo *************************************************************************
echo.
goto :the_end

:cmdfail
echo *************************************************************************
echo *** TEST FAILED ***
echo *************************************************************************
echo.
echo Command "%runcmd%" failed
echo.

:the_end
